


extern BOOL GateUp;
extern	FEATURE	*testFeat;


BOOL intUpdateGates(GATE *psGate);	// update already open order form

#define NUM_GATE_OPTIONS 2			// Number of option lines on the menu (in OrderGateButtons list).
#define MAX_DISPL_GATE_OPTS 2	// Max number of displayable gate options.
#define MAX_GATE_BUTS 5				// Max number of buttons for a given gate state.

//Starting Widget button IDs for state buttons
#define IDGATE_LOCK_STATE				15010
#define IDGATE_ALLY_LOCK_STATE			15020
#define IDGATE_CLOSE_STATE				15030

// menu options for gates
typedef enum _gate_options
{
	GT_LOCK_STATE,				//If locked
	GT_ALLY_LOCK_STATE,			//If locked for allies
	GT_CLOSE_STATE,				//If closed
} MENU_GATE_OPTIONS;

// the state of gte options (for each line of buttons)
typedef enum _gate_state
{
	GSS_LOCK_NORMAL,				//= 0x000001,
	GSS_LOCK_FORCE_LOCK,			//= 0x000002,
	GSS_LOCK_FORCE_UNLOCK,		//= 0x000003,

	GSS_ALOCK_NORMAL,			//= 0x000004,
	GSS_ALOCK_LOCKED,			//= 0x000008,

	GSS_CLOSE_CLOSED,			//= 0x00000c,
	GSS_CLOSE_OPEN,				//= 0x000010,
} MENU_GATE_STATE;

// masks for the gate state
//#define GSS_LOCK_MASK		0x000003		//GSS_LOCK_FORCE_UNLOCK
//#define GSS_ALOCK_MASK		0x000008		//GSS_CLOSE_OPEN
//#define GSS_CLOSE_MASK		0x000010		//GSS_ALOCK_LOCKED

#define GSS_LOCK_MASK		0		//GSS_LOCK_FORCE_UNLOCK
#define GSS_ALOCK_MASK		3		//GSS_CLOSE_OPEN
#define GSS_CLOSE_MASK		5		//GSS_ALOCK_LOCKED

#define GT_JUSTIFY_MASK	0x0f
#define GT_JUSTIFY_NEWLINE	0x10	// Or with ORDBUTTONJUSTIFY enum type to specify start on new line.

typedef enum {
	GT_JUSTIFY_LEFT,			// Pretty self explanatory really.
	GT_JUSTIFY_RIGHT,
	GT_JUSTIFY_CENTER,
	GT_JUSTIFY_COMBINE,		// allow the button to be put on the same line
								// as other orders with the same justify type
	GT_NUM_JUSTIFY_TYPES,
} GTBUTTONJUSTIFY;

typedef enum {
	GT_BTYPE_RADIO,			// Only one state allowed.
	GT_BTYPE_BOOLEAN,			// Clicking on a button toggles it's state.
	GT_BTYPE_BOOLEAN_DEPEND,	// Clicking on a button toggles it's state, button
								// is only enabled if previous button is down.
	GT_BTYPE_BOOLEAN_COMBINE,	// Clicking on a button toggles it's state, all
								// the buttons states are OR'ed together to get the order state
} GTBUTTONTYPE;


typedef struct {
	//ORDBUTTONCLASS Class;					// The class of button.
	MENU_GATE_OPTIONS GateState;					// The droid order.
	UDWORD StateMask;						// It's state mask.
	GTBUTTONTYPE ButType;					// The group type.
	GTBUTTONJUSTIFY ButJustify;			// Button justification.
	UDWORD ButBaseID;						// Starting widget ID for buttons
	UWORD NumButs;							// Number of buttons ( = number of states )
	UWORD AcNumButs;						// Actual bumber of buttons enabled.
	UWORD ButImageID[MAX_GATE_BUTS];		// Image ID's for each button ( normal ).
	UWORD ButGreyID[MAX_GATE_BUTS];		// Image ID's for each button ( greyed ).
	UWORD ButHilightID[MAX_GATE_BUTS];		// Image ID's for each button ( hilight overlay ).
	UWORD ButTips[MAX_GATE_BUTS];			// Tip string id for each button.
	MENU_GATE_STATE States[MAX_GATE_BUTS];	// Order state relating to each button.
} MENU_GATE;
